
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_sobelProc is
end entity tb_sobelProc;

architecture archi_tb_sobelProc of tb_sobelProc is

    component sobelProc is
        port (I_clk          : in  std_logic;
              I_rst          : in  std_logic;
              I_go           : in  std_logic;
              -- interface avec la mémoire IN (lecture)
              O_enM_R        : out std_logic;
              O_ADR_R        : out std_logic_vector (13 downto 0);
              I_pixel        : in  std_logic_vector (7 downto 0);  -- Pixel from memory IN
              -- interface avec la mémoire OUT (écriture)
              O_enM_W        : out std_logic;
              O_ADR_W        : out std_logic_vector (13 downto 0);
              O_pixEdge      : out std_logic;                      -- Edge to memory OUT
              -- signal de commande vers le contrôleur VGA
              O_StartDisplay : out std_logic
              );
    end component sobelProc;

    signal S_clk          : std_logic := '0';
    signal S_I_rst        : std_logic;
    signal S_go           : std_logic;
    signal S_enM_R        : std_logic;
    signal S_ADR_R        : std_logic_vector (13 downto 0);
    signal S_pixel        : std_logic_vector (7 downto 0);
    signal S_enM_W        : std_logic;
    signal S_ADR_W        : std_logic_vector (13 downto 0);
    signal S_pixEdge      : std_logic;
    signal S_StartDisplay : std_logic;

begin

    S_pixel <= "00000111";

    S_clk   <= not S_clk after 5 ns;
    S_I_rst <= '1', '0'  after 64 ns;
    S_go    <= '0', '1'  after 164 ns, '0' after 264 ns;

    sobelProc_1 : entity work.sobelProc
        port map (
            I_clk          => S_clk,
            I_rst          => S_I_rst,
            I_go           => S_go,
            O_enM_R        => S_enM_R,
            O_ADR_R        => S_ADR_R,
            I_pixel        => S_pixel,
            O_enM_W        => S_enM_W,
            O_ADR_W        => S_ADR_W,
            O_pixEdge      => S_pixEdge,
            O_StartDisplay => S_StartDisplay
            );

end architecture archi_tb_sobelProc;
