
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_sobelSys is
end entity tb_sobelSys;

architecture archi_tb_sobelSys of tb_sobelSys is

    component sobelSys is
        port (I_clk       : in  std_logic;
              I_rst       : in  std_logic;
              I_go        : in  std_logic;
              -- VGA Output Signals
              O_vga_hs    : out std_logic;                      -- HSYNC OUT
              O_vga_vs    : out std_logic;                      -- VSYNC OUT
              O_vga_red   : out std_logic_vector (3 downto 0);  -- Red signal going to the VGA interface
              O_vga_green : out std_logic_vector (3 downto 0);  -- Green signal going to the VGA interface
              O_vga_blue  : out std_logic_vector (3 downto 0)   -- Blue signal going to the VGA interface
              );
    end component sobelSys;

    signal S_I_clk       : std_logic := '0';
    signal S_I_rst       : std_logic;
    signal S_go_i        : std_logic;
    signal S_vga_hs_o    : std_logic;
    signal S_vga_vs_o    : std_logic;
    signal S_vga_red_o   : std_logic_vector (3 downto 0);
    signal S_vga_green_o : std_logic_vector (3 downto 0);
    signal S_vga_blue_o  : std_logic_vector (3 downto 0);

begin

    S_I_clk <= not S_I_clk after 5 ns;
    S_I_rst <= '1', '0'    after 2064 ns;
    S_go_i  <= '0', '1'    after 2264 ns, '0' after 2664 ns;

    sobelSys_1 : entity work.sobelSys
        port map (
            I_clk       => S_I_clk,
            I_rst       => S_I_rst,
            I_go        => S_go_i,
            O_vga_hs    => S_vga_hs_o,
            O_vga_vs    => S_vga_vs_o,
            O_vga_red   => S_vga_red_o,
            O_vga_green => S_vga_green_o,
            O_vga_blue  => S_vga_blue_o
            );

end architecture archi_tb_sobelSys;
